org.apache.ignite.internal.util.io

## Class GridByteArrayOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.ignite.internal.util.io.GridByteArrayOutputStream

All Implemented Interfaces:
  Closeable, Flushable, AutoCloseable

    public class GridByteArrayOutputStream
    extends OutputStream

This class defines output stream backed by byte array. It is identical to `ByteArrayOutputStream` with no synchronization.

### Constructor Summary

Constructors
Constructor and Description
`GridByteArrayOutputStream()` Creates a new byte array output stream.
`GridByteArrayOutputStream(int size)`
`GridByteArrayOutputStream(int size, int off)`

### Method Summary

Methods
`byte[]` `internalArray()` Returns internal array without copy (use with care).
`void` `reset()` Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the output stream is discarded.
`int` `size()` Returns the current size of the buffer.
`byte[]` `toByteArray()` Creates a newly allocated byte array.
`String` `toString()`
`void` `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.
`void` `write(int b)` Writes the specified byte to this byte array output stream.
`void` `writeTo(OutputStream out)` Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

### Methods inherited from class java.io.OutputStream

`close, flush, write`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### GridByteArrayOutputStream

    public GridByteArrayOutputStream()

Creates a new byte array output stream. The buffer capacity is initially 32 bytes, though its size increases if necessary.

#### GridByteArrayOutputStream

    public GridByteArrayOutputStream(int size)

Parameters:
  `size` - Byte array size.

#### GridByteArrayOutputStream

    public GridByteArrayOutputStream(int size,
                             int off)

Parameters:
  `size` - Byte array size.
  `off` - Offset from which to write.

### Method Detail

#### write

    public void write(int b)

Writes the specified byte to this byte array output stream.

Specified by:
  `write` in class `OutputStream`
Parameters:
  `b` - the byte to be written.

#### write

    public void write(byte[] b,
             int off,
             int len)

Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.

Overrides:
  `write` in class `OutputStream`
Parameters:
  `b` - the data.
  `off` - the start offset in the data.
  `len` - the number of bytes to write.

#### writeTo

    public void writeTo(OutputStream out)
                 throws IOException

Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

Parameters:
  `out` - the output stream to which to write the data.
Throws:
  `IOException` - if an I/O error occurs.

#### reset

    public void reset()

Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the output stream is discarded. The output stream can be used again, reusing the already allocated buffer space.

See Also:
  `ByteArrayInputStream.count`

#### internalArray

    public byte[] internalArray()

Returns internal array without copy (use with care).

Returns:
  Internal array without copy.

#### toByteArray

    public byte[] toByteArray()

Creates a newly allocated byte array. Its size is the current size of this output stream and the valid contents of the buffer have been copied into it.

Returns:
  the current contents of this output stream, as a byte array.
See Also:
  `ByteArrayOutputStream.size()`

#### size

    public int size()

Returns the current size of the buffer.

Returns:
  the value of the `count` field, which is the number of valid bytes in this output stream.
See Also:
  `ByteArrayOutputStream.count`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.1.0-incubating
Release Date | : May 20 2015